// Car receiver for sunfounder remote
// www.fambach.net
// GPL2
/***********************************************************/
//#define ONLY_DISPLAY // remove this if you want to only test the rf
/***********************************************************/
#ifndef  ONLY_DISPLAY
#include "drive.h"
Drive drive;
#endif

/***********************************************************/
// radio
#include <SPI.h>
#include "nRF24L01.h"
#include "RF24.h"

#define SWITCH 0
#define X 1
#define Y 2

#define PIN_CE   9
#define PIN_CSN 10
RF24 radio(PIN_CE, PIN_CSN);
byte addresses[][6] = {"007", "001"};
int data[3] = {0, 512, 512};
int cur_data[3] = {0, 512, 512};


/***********************************************************/

void setup() {
  Serial.begin(9600);

#ifndef  ONLY_DISPLAY
    drive.init();
#endif

  Serial.println("init rf");
  radio.begin();                      // initialize RF24
  radio.setRetries(0, 15);            // set retries times
  radio.setPALevel(RF24_PA_LOW);      // set power
  radio.openWritingPipe(addresses[0]);
  radio.openReadingPipe(1, addresses[1]);
  radio.startListening();             // start monitoring

}

#ifndef  ONLY_DISPLAY

#endif
void loop()
{
  // receive data ;)
  receiveData();
}



void receiveData() {
  if ( radio.available()) {            // if receive the data

    // Read the data payload until we've received everything
    bool done = false;
    while (radio.available())
    {
      // Fetch the data payload
      radio.read( data, sizeof(data) );
      //      Serial.print("SWITCH = ");
      //      Serial.print(data[SWITCH]);
      //      Serial.print(" X = ");
      //      Serial.print(data[X]);
      //      Serial.print(" Y = ");
      //      Serial.println(data[Y]);

#ifndef  ONLY_DISPLAY

      // check if something has changed
      if (data[0] != cur_data[0] ||
          data[1] != cur_data[1] ||
          data[2] != cur_data[2]) {
        // if yes change the drive
        memcpy(cur_data, data, sizeof(data));
        drive.process(cur_data[Y], cur_data[X]);
      }

#endif

    }
  }
  else
  {
    // Serial.println("No radio available"); //only for test purpose
  }
}


